' Small script to remove tags from srt subtitles files and to create an ass version
' Author : Vincent aka Lama
' Modified by Dapitch666, adjusted for the Lords of Kobol by Bbsiocnarf and terminated by Golgi =)
'
' To use this script, simply drag and drop the files onto
' the icon of the script. You can also do it from the command line
' by typing cscript RemoveTags.vbs <files>
' Of course this does only work in Windows (98 & later).
'
' Unless there is an error, there is no output!
'
' I'm in no way an expert in VBScript programming (it's pretty obvious
' from the programming style) and I don't want to be ;-).
' This script is provided in the hope that it will be helpful to some,
' and comes with no warranty (backuping your data first is the way to go).


Dim Extensions        ' Extensions of the files to be processed
Dim FilesToProcess()  ' Files to be processed
Dim PatternsASS
Dim PatternsNoTag

' For NoTag
PatternsNoTag = Array(Array("{.*?}", ""), Array("", "oe"), Array("", "ae"), Array("", "Oe"), Array("", "Ae"), Array("<u>", ""), Array("<b>", ""), Array("</u>", ""), Array("</b>", ""))

' For ASS
PatternsASS = Array(Array("<i>", "{\i1}"), Array("</i>", "{\i0}"), Array("<u>","{\u1}"), Array("</u>","{\u0}"), Array("<b>","{\b1}"), Array("</b>","{\b0}"))


' Here we only process TAG .srt files
Extensions="\.srt"

Set objArgs = WScript.Arguments

i = 0
j = 0

Set objRE = New RegExp
objRE.IgnoreCase = True
objRE.Pattern = Extensions

Set reTags = New RegExp
reTags.Global  = True

' See what file we need to process
ReDim FilesToProcess(WScript.Arguments.Count - 1)
Do While i <= WScript.Arguments.Count - 1
    arg = WScript.Arguments.Item(i)

    Set Matches = objRE.Execute(arg)

    For Each Match In Matches
        If Match.firstIndex > 0 Then
            FilesToProcess(j) = arg
            Rem Wscript.Echo Cstr(i) + " > " + arg
            j = j + 1
        End If
    Next

    i = i+ 1
Loop

' Make a backup (named after the filename + ".bak") 
For Each file in FilesToProcess
    If StrComp(file, "") <> 0 Then
        Set objInputFSO   = CreateObject("Scripting.FileSystemObject")
        objInputFSO.CopyFile file, file & ".bak"
        objInputFSO.DeleteFile file, True
    End If
Next

' Open the backup file and process it
Set reEmptyLine = New RegExp
reEmptyLine.Pattern = PatternsEmptyLine

Set reTags = New RegExp
reTags.Pattern = PatternsTags
reTags.Global  = True

For Each file in FilesToProcess
    If StrComp(file, "") <> 0 Then
        Set objInputFSO   = CreateObject("Scripting.FileSystemObject")
        Set objInputFile  = objInputFSO.OpenTextFile(file & ".bak")

        Set objOutputFSO  = CreateObject("Scripting.FileSystemObject")
        Set objOutputFile = objOutputFSO.CreateTextFile(file)
        Do While objInputFile.AtEndOfStream <> True
            inputLine = objInputFile.ReadLine

            If StrComp(inputLine, "") = 0 Then
                objOutputFile.WriteLine(inputLine)
            Else
				outputLine = inputLine
                If  StrComp(outputLine, "") <> 0 Then
                    For Each Pattern In PatternsNoTag
                      reTags.Pattern = Pattern(0)
                      outputLine = reTags.Replace(outputLine, Pattern(1))
                    Next
                    objOutputFile.WriteLine(outputLine)
                End If
            End If
        Loop
    End If
Next